Loading...
Searching...
No Matches
juce::AudioTransportSource Class Reference

## Detailed Description

An AudioSource that takes a PositionableAudioSource and allows it to be played, stopped, started, etc.

This can also be told use a buffer and background thread to read ahead, and if can correct for different sample-rates.

You may want to use one of these along with an AudioSourcePlayer and AudioIODevice to control playback of an audio file.

See also
  AudioSource, AudioSourcePlayer

The documentation for this class was generated from the following file:

- juce_audio_devices/sources/juce_AudioTransportSource.h

Inheritance diagram for juce::AudioTransportSource:

## Public Member Functions

| AudioTransportSource ()
| Creates an AudioTransportSource.
| ~AudioTransportSource () override
| Destructor.
void | setSource (PositionableAudioSource *newSource, int readAheadBufferSize=0, TimeSliceThread *readAheadThread=nullptr, double sourceSampleRateToCorrectFor=0.0, int maxNumChannels=2)
| Sets the reader that is being used as the input source.
void | setPosition (double newPosition)
| Changes the current playback position in the source stream.
double | getCurrentPosition () const
| Returns the position that the next data block will be read from.
double | getLengthInSeconds () const
| Returns the stream's length in seconds.
bool | hasStreamFinished () const noexcept
| Returns true if the player has stopped because its input stream ran out of data.
void | start ()
| Starts playing (if a source has been selected).
void | stop ()
| Stops playing.
bool | isPlaying () const noexcept
| Returns true if it's currently playing.
void | setGain (float newGain) noexcept
| Changes the gain to apply to the output.
float | getGain () const noexcept
| Returns the current gain setting.
void | prepareToPlay (int samplesPerBlockExpected, double sampleRate) override
| Implementation of the AudioSource method.
void | releaseResources () override
| Implementation of the AudioSource method.
void | getNextAudioBlock (const AudioSourceChannelInfo &) override
| Implementation of the AudioSource method.
void | setNextReadPosition (int64 newPosition) override
| Implements the PositionableAudioSource method.
int64 | getNextReadPosition () const override
| Implements the PositionableAudioSource method.
int64 | getTotalLength () const override
| Implements the PositionableAudioSource method.
bool | isLooping () const override
| Implements the PositionableAudioSource method.
Public Member Functions inherited from juce::PositionableAudioSource
| ~PositionableAudioSource () override=default
| Destructor.
virtual void | setLooping (bool shouldLoop)
| Tells the source whether you'd like it to play in a loop.
Public Member Functions inherited from juce::AudioSource
virtual | ~AudioSource ()=default
| Destructor.
Public Member Functions inherited from juce::ChangeBroadcaster
| ChangeBroadcaster () noexcept
| Creates an ChangeBroadcaster.
virtual | ~ChangeBroadcaster ()
| Destructor.
void | addChangeListener (ChangeListener *listener)
| Registers a listener to receive change callbacks from this broadcaster.
void | removeChangeListener (ChangeListener *listener)
| Unregisters a listener from the list.
void | removeAllChangeListeners ()
| Removes all listeners from the list.
void | sendChangeMessage ()
| Causes an asynchronous change message to be sent to all the registered listeners.
void | sendSynchronousChangeMessage ()
| Sends a synchronous change message to all the registered listeners.
void | dispatchPendingMessages ()
| If a change message has been sent but not yet dispatched, this will call sendSynchronousChangeMessage() to make the callback immediately.

## Additional Inherited Members

Protected Member Functions inherited from juce::PositionableAudioSource
| PositionableAudioSource ()=default
| Creates the PositionableAudioSource.
Protected Member Functions inherited from juce::AudioSource
| AudioSource ()=default
| Creates an AudioSource.

## Constructors and Destructors

## AudioTransportSource()

juce::AudioTransportSource::AudioTransportSource | ( |  | ) |

Creates an AudioTransportSource.

After creating one of these, use the setSource() method to select an input source.

## ~AudioTransportSource()

juce::AudioTransportSource::~AudioTransportSource | ( |  | ) |

override

Destructor.

## Member Functions

## setSource()

void juce::AudioTransportSource::setSource | ( | PositionableAudioSource * | newSource,
|  | int | readAheadBufferSize = 0,
|  | TimeSliceThread * | readAheadThread = nullptr,
|  | double | sourceSampleRateToCorrectFor = 0.0,
|  | int | maxNumChannels = 2 )

Sets the reader that is being used as the input source.

This will stop playback, reset the position to 0 and change to the new reader.

The source passed in will not be deleted by this object, so must be managed by the caller.

Parameters

  newSource | the new input source to use. This may be a nullptr
  readAheadBufferSize | a size of buffer to use for reading ahead. If this is zero, no reading ahead will be done; if it's greater than zero, a BufferingAudioSource will be used to do the reading-ahead. If you set a non-zero value here, you'll also need to set the readAheadThread parameter.
  readAheadThread | if you set readAheadBufferSize to a non-zero value, then you'll also need to supply this TimeSliceThread object for the background reader to use. The thread object must not be deleted while the AudioTransport source is still using it.
  sourceSampleRateToCorrectFor | if this is non-zero, it specifies the sample rate of the source, and playback will be sample-rate adjusted to maintain playback at the correct pitch. If this is 0, no sample-rate adjustment will be performed
  maxNumChannels | the maximum number of channels that may need to be played

References juce::PositionableAudioSource::PositionableAudioSource().

## setPosition()

void juce::AudioTransportSource::setPosition | ( | double | newPosition | ) |

Changes the current playback position in the source stream.

The next time the getNextAudioBlock() method is called, this is the time from which it'll read data.

Parameters

  newPosition | the new playback position in seconds

See also
  getCurrentPosition

## getCurrentPosition()

double juce::AudioTransportSource::getCurrentPosition | ( |  | ) | const

Returns the position that the next data block will be read from.

This is a time in seconds.

## getLengthInSeconds()

double juce::AudioTransportSource::getLengthInSeconds | ( |  | ) | const

Returns the stream's length in seconds.

## hasStreamFinished()

bool juce::AudioTransportSource::hasStreamFinished | ( |  | ) | const

noexcept

Returns true if the player has stopped because its input stream ran out of data.

## start()

void juce::AudioTransportSource::start | ( |  | ) |

Starts playing (if a source has been selected).

If it starts playing, this will send a message to any ChangeListeners that are registered with this object.

References start().

Referenced by start().

## stop()

void juce::AudioTransportSource::stop | ( |  | ) |

Stops playing.

If it's actually playing, this will send a message to any ChangeListeners that are registered with this object.

References stop().

Referenced by stop().

## isPlaying()

bool juce::AudioTransportSource::isPlaying | ( |  | ) | const

inline noexcept

Returns true if it's currently playing.

References isPlaying().

Referenced by isPlaying().

## setGain()

void juce::AudioTransportSource::setGain | ( | float | newGain | ) |

noexcept

Changes the gain to apply to the output.

Parameters

  newGain | a factor by which to multiply the outgoing samples, so 1.0 = 0dB, 0.5 = -6dB, 2.0 = 6dB, etc.

## getGain()

float juce::AudioTransportSource::getGain | ( |  | ) | const

inline noexcept

Returns the current gain setting.

See also
  setGain

## prepareToPlay()

void juce::AudioTransportSource::prepareToPlay | ( | int | samplesPerBlockExpected,
|  | double | sampleRate )

override virtual

Implementation of the AudioSource method.

Implements juce::AudioSource.

## releaseResources()

void juce::AudioTransportSource::releaseResources | ( |  | ) |

override virtual

Implementation of the AudioSource method.

Implements juce::AudioSource.

## getNextAudioBlock()

void juce::AudioTransportSource::getNextAudioBlock | ( | const AudioSourceChannelInfo & |  | ) |

override virtual

Implementation of the AudioSource method.

Implements juce::AudioSource.

## setNextReadPosition()

void juce::AudioTransportSource::setNextReadPosition | ( | int64 | newPosition | ) |

override virtual

Implements the PositionableAudioSource method.

Implements juce::PositionableAudioSource.

## getNextReadPosition()

int64 juce::AudioTransportSource::getNextReadPosition | ( |  | ) | const

override virtual

Implements the PositionableAudioSource method.

Implements juce::PositionableAudioSource.

## getTotalLength()

int64 juce::AudioTransportSource::getTotalLength | ( |  | ) | const

override virtual

Implements the PositionableAudioSource method.

Implements juce::PositionableAudioSource.

## isLooping()

bool juce::AudioTransportSource::isLooping | ( |  | ) | const

override virtual

Implements the PositionableAudioSource method.

Implements juce::PositionableAudioSource.

References juce::PositionableAudioSource::PositionableAudioSource().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited